/*
 * BernsteinPolynomialsApplet.java
 *
 * Created on 28. Juli 2007, 13:12
 *
 * Draws the Bernstein polynomials.
 */

/**
 *
 * @author  Sunshine
 */
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


public class BernsteinPolynomialsApplet extends javax.swing.JApplet {
   private DrawingPanel drawPanel;

   private int sizex = 500;
   private int sizey = 420;
    /** Initializes the applet QuadraticBezierApplet */
    public void init() {
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }


        drawPanel = new DrawingPanel();
        getContentPane().add(drawPanel);
        ParameterField.setText("0.5");

        setSize(sizex, sizey);
        jPanel1.setBounds(0, 350, 500, 80);

        // react on slider
        this.ParameterSlider.addChangeListener(new ChangeListener()
        {
            public void stateChanged(ChangeEvent event)
            {
                float slidervalue = (float)ParameterSlider.getValue() / 1000;
                ParameterField.setText(Float.toString(slidervalue));
                drawPanel.t = slidervalue;
                drawPanel.repaint();
            }
        });

        // react on textfield actions
        this.ParameterField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event)
            {
                float slidervalue;
                try {
                    slidervalue = Float.parseFloat(ParameterField.getText());
                } catch (NumberFormatException ex) { return; }
                if (slidervalue < 0 || slidervalue > 1) return;
                drawPanel.t = slidervalue;
                drawPanel.repaint();
                ParameterSlider.setValue((int)(slidervalue * 1000));
            }
        });

        for (int i = 0; i < 13; i++)
            DegreeCombobox.addItem(new Integer(i));
        DegreeCombobox.setSelectedIndex(1);

        // react on degree combobox
        DegreeCombobox.addActionListener( new ActionListener()
        {
            public void actionPerformed( ActionEvent e )
            {
                drawPanel.degree = DegreeCombobox.getSelectedIndex();

                SelectCombobox.removeAllItems();
                for (int i = 0; i <= drawPanel.degree; i++)
                    SelectCombobox.addItem(new Integer(i));

                drawPanel.repaint();
            }
        } );


        for (int i = 0; i < 2; i++)
            SelectCombobox.addItem(new Integer(i));

        // react on select-degree combobox
        SelectCombobox.addActionListener( new ActionListener()
        {
            public void actionPerformed( ActionEvent e )
            {
                drawPanel.selectedCurve = SelectCombobox.getSelectedIndex();
                drawPanel.repaint();
            }
        } );

    }

    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        ParameterSlider = new javax.swing.JSlider();
        jLabel5 = new javax.swing.JLabel();
        ParameterField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        DegreeCombobox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        SelectCombobox = new javax.swing.JComboBox();

        getContentPane().setLayout(null);

        jPanel1.setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        ParameterSlider.setMaximum(1000);
        ParameterSlider.setValue(500);
        jPanel1.add(ParameterSlider);
        ParameterSlider.setBounds(20, 10, 200, 24);

        jLabel5.setText("t =");
        jPanel1.add(jLabel5);
        jLabel5.setBounds(50, 45, 15, 14);

        jPanel1.add(ParameterField);
        ParameterField.setBounds(70, 40, 60, 20);

        jLabel6.setText("0 <= t <= 1");
        jPanel1.add(jLabel6);
        jLabel6.setBounds(140, 45, 60, 14);

        jPanel1.add(DegreeCombobox);
        DegreeCombobox.setBounds(250, 40, 80, 22);

        jLabel1.setText("Degree:");
        jPanel1.add(jLabel1);
        jLabel1.setBounds(250, 20, 50, 14);

        jLabel2.setText("Select:");
        jPanel1.add(jLabel2);
        jLabel2.setBounds(350, 20, 60, 14);

        jPanel1.add(SelectCombobox);
        SelectCombobox.setBounds(350, 40, 60, 22);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(10, 200, 440, 100);

    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox DegreeCombobox;
    private javax.swing.JTextField ParameterField;
    private javax.swing.JSlider ParameterSlider;
    private javax.swing.JComboBox SelectCombobox;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables

}
