import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import javax.swing.JPanel;
/*
 * DrawingPanel.java
 *
 * Created on 4. Juli 2007, 22:59
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 *
 * @author Sunshine
 */
public class DrawingPanel extends JPanel {
    
    public static int originX = 50;
    public static int originY = 320;
    public static int zoomfactor = 300;
    
    public int degree = 1;
    public int selectedCurve = 0;
   
    public float t = 0.5f;
    
    /** Creates a new instance of DrawingPanel */
    public DrawingPanel() {
       this.setLayout(null);
       this.setBounds(0, 0, 500, 350);
       this.setBackground(new Color(0, 153, 255));
       
      
    }
    
    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D)g;
        
        // draw the x-axis
        g2.drawLine(originX, originY, 400 + originX, originY);
        // draw the y-axis
        g2.drawLine(originX, originY, originX, originY - zoomfactor);
        // draw values on the axis
        g2.setFont(new Font("Arial", Font.BOLD, 12));
        FontMetrics fm = g2.getFontMetrics();
        int strWidth = fm.stringWidth("0");
        int strHeight = fm.getHeight();
        g2.drawString("0", originX - strWidth/2, originY + 15);
        g2.drawString("1", originX + 400 - strWidth/2, originY + 15);
        g2.drawString("1", originX - 10, originY - zoomfactor + strHeight / 2);
        
        drawBernsteinPolys(g2, this.degree);
        
        // draw current t value
        g2.setColor(Color.RED);
        //g2.drawLine((int)(originX + t * 400), originY, (int)(originX + t * 400), originY - zoomfactor);
        double y;
        for (int i = 0; i <= degree; i++)
        {
            y = evalBernstein(t, degree, i);
            g2.fillRect((int)(originX + t * 400)-1, (int)(originY - y*zoomfactor)-1, 3, 3);
        }
      
    }
   
    private void drawBernsteinPolys(Graphics2D g, int degree)
    {
        double y;
        int  count;
        
        double oldPosy;       // the point drawn one iteration before
        for (int i = 0; i <= degree; i++)
        {
            y = 0;
            count = originX;
            
            if (i == this.selectedCurve)
                g.setColor(Color.GREEN);
            else
                g.setColor(Color.BLACK);
            
            oldPosy = evalBernstein(0, degree, i);
            for (float t = 0.0025f; t <= 1.00f; t += 0.0025f)
            {
                y = evalBernstein(t, degree, i);
                g.drawLine(count, originY-(int)(oldPosy * zoomfactor), count ++, originY-(int)(y* zoomfactor));
                oldPosy = y;
            }
        }
    }
    
    private void drawOneBersteinPoly(Graphics2D g, int degreem, int i)
    {
        
    }
    /*
     * Evaluate Berstein polynomial i of degree n at position t (0 <= t <= 1)
     */
    private double evalBernstein(float t, int degree, int i)
    {
        return bincoeff(degree,i) * Math.pow(t,i) * Math.pow(1-t, degree-i);
    }
    
    


    // *** here are some helper functions
    
    /*
     * Calcluate n! Recursive function
     */
    private int fak(int n)
    {
        if (n <= 0) return 1;
        else return n * fak(n-1);
    }
    
    /*
     * Calculate a binomial coefficient, the very lame way
     */
    private int bincoeff(int n, int i)
    {
        if (i < 0 || i > n) return 0;
        else
            return (fak(n) / (fak(i) * fak(n-i)) );
    }
}
